
using System;
using System.Collections.Generic;

namespace PDim2Rigid {

    public class HitDataLong {

        private int Fage = maxAge;
        private static int maxAge = 256;

        public int age {
            get {
                return Fage;
            }
        }

        public HitDataShort hds = null;
        public RigidBody rb1, rb2;
        public int edge1, edge2;
        public float force = 0;
        public float vel = 0;
        public float fric = 0;
        
        public bool isEqual(HitDataLong hdl) {
            return (rb1 == hdl.rb1 && rb2 == hdl.rb2
                    && edge1 == hdl.edge1 && edge2 == hdl.edge2)
                || (rb1 == hdl.rb2 && rb2 == hdl.rb1
                    && edge1 == hdl.edge2 && edge2 == hdl.edge1);                
        }

        public void setMaxAge(HitDataShort ahds) {
            Fage = maxAge;
            hds = ahds;
        }

        public bool decAge() {
            Fage -= 1;
            hds = null;
            return (Fage <= 0);
        }

        public bool isMaxAge() {
            return (Fage == maxAge);
        }
    }

    public class HitDataShort {        

        public int index = -1;
        public HitDataLong hdl = null;
        public float h = 0.0F;
        public Dim2Vector n = new Dim2Vector();
        public Dim2Vector fn = new Dim2Vector();
        public Dim2Vector r1 = new Dim2Vector();
        public Dim2Vector r2 = new Dim2Vector();

        public float impulseConst = 0.4f;//ꂪ}CiX̏ꍇ͊֐
        public float fricConst = 0.9f;


        public RigidBody rb1 {
            get { return hdl.rb1; }
        }

        public RigidBody rb2 {
            get { return hdl.rb2; }
        }

    }

    public class HitData2 {
        public HitDataShort hds = null;
        public RigidGroup rg1, rg2;
        public Dim2Vector newR1, newR2;
        public int newIndex = -1;
    }


}
